package com.supervision.police.dto.user;

import cn.hutool.core.util.StrUtil;
import com.baomidou.mybatisplus.annotation.TableId;
import com.supervision.police.domain.SystemUser;
import lombok.Data;
import org.springframework.scheduling.support.SimpleTriggerContext;

import java.time.LocalDateTime;
import java.util.*;

@Data
public class UserInfoDTO {


    /**
     * 主键
     */
    @TableId
    private String id;

    /**
     * 头像id
     */
    private String headPicId;

    /**
     * 账户名
     */
    private String account;

    /**
     * 用户名
     */
    private String userName;

    /**
     * 手机号码
     */
    private String phoneNum;

    /**
     * 账号状态 0正常 1停用
     */
    private Integer status;


    private List<UserRoleDTO> userRoleList;
    /**
     * 最近登录时间
     */
    private LocalDateTime recentLoginTime;

    public UserInfoDTO() {
    }

    public UserInfoDTO(SystemUser systemUser) {
        systemUserSetter(systemUser);
    }

    public UserInfoDTO(SystemUser systemUser, Map<String, List<UserRoleDTO>> userRoleMap) {
        systemUserSetter(systemUser);
        if (StrUtil.isNotEmpty(this.id)){
            this.setUserRoleList(userRoleMap.getOrDefault(this.id, new ArrayList<>(1)));
        }
    }

    private void systemUserSetter(SystemUser systemUser){
        if (Objects.isNull(systemUser)){
            return;
        }
        this.id = systemUser.getId();
        this.headPicId = systemUser.getHeadPicId();
        this.account = systemUser.getAccount();
        this.userName = systemUser.getUserName();
        this.phoneNum = systemUser.getPhoneNum();
        this.status = systemUser.getStatus();
        this.recentLoginTime = systemUser.getRecentLoginTime();
    }

}
